import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.Statement;

public class ReportGenerator {

    private static final String DATABASE_URL = "jdbc:odbc:driver={Microsoft Access Driver (*.mdb)};DBQ=./db/Nwind.mdb";
    private static final String OUTPUT_PATH = "./out/";

    public static void main(String[] args) throws Exception {

        Connection connection = null;
        Statement statement = null;

        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");

            // Create connection and execute SQL statement
            connection = DriverManager.getConnection(DATABASE_URL);
            statement = connection.createStatement();

            long startTime;
            
            // Create Product report
            System.out.print("Creating Product report...");
            startTime = System.currentTimeMillis();
            ProductReport report = new ProductReport();
            report.createReport(statement, OUTPUT_PATH);
            System.out.println("   " + (System.currentTimeMillis() - startTime) + "ms");

            // Create Invoice report 1
            System.out.print("Creating Invoice1 report...");
            startTime = System.currentTimeMillis();
            InvoiceReport1 report1 = new InvoiceReport1();
            report1.createReport(statement, OUTPUT_PATH);
            System.out.println("   " + (System.currentTimeMillis() - startTime) + "ms");

            // Create Invoice report 2
            System.out.print("Creating Invoice2 report...");
            startTime = System.currentTimeMillis();
            InvoiceReport2 report2 = new InvoiceReport2();
            report2.createReport(statement, OUTPUT_PATH);
            System.out.println("   " + (System.currentTimeMillis() - startTime) + "ms");

            // Create Sales report
            System.out.print("Creating Sales report...");
            startTime = System.currentTimeMillis();
            SalesReport report3 = new SalesReport();
            report3.createReport(statement, OUTPUT_PATH);
            System.out.println("   " + (System.currentTimeMillis() - startTime) + "ms");

            statement.close();
            connection.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
